#include "capital.h"

int main( int argc, char **argv ) {
   vector<town> country;
   int xmin = 9999, xmax = -9999, ymin = 9999, ymax = -9999;
   while( true ) {
      string s;   
      getline( cin, s );
      if( !cin || 0 == s.length() ) break;
      town p; 
      istringstream( s ) >> p.x >> p.y;
      xmin = p.x < xmin ? p.x : xmin;
      xmax = p.x > xmax ? p.x : xmax;
      ymin = p.y < ymin ? p.y : ymin;
      ymax = p.y > ymax ? p.y : ymax; 
      country.push_back( p );
   }
   cout  << "городов " << country.size() << " : ";  
   for( auto &p : country ) cout << p << "  ";
   cout << endl;
   xmin -= 1; xmax += 1; ymin -= 1; ymax += 1;
   cout << "границы поля: [" << xmin << "..." << xmax 
        << ',' << ymin << "..." << ymax << "]" << endl;
   town capital = { xmin, ymin };
   unsigned distanse = summa( country, capital ), m = 0;
   for( int x = xmin; x <= xmax; x++ )
      for( int y = ymin; y <= ymax; y++ ) {
         town point = { x, y };
         if( find( country.begin(), country.end(), point ) != country.end() ) continue;
         unsigned d = summa( country, point );
         if( d < distanse ) {
            distanse = d;
            capital = point;
         }
         m++;
      }
   cout << "столица " << capital << " среднее расстояние " 
        << (float)distanse / country.size() << " число проб " << m << endl;       
}
