#include "capital.h"

int main( int argc, char **argv ) {
   vector<town> country;
   double xm = 0, ym = 0;
   while( true ) {
      string s;   
      getline( cin, s );
      if( !cin || 0 == s.length() ) break;
      town p; 
      istringstream( s ) >> p.x >> p.y;
      xm += p.x;
      ym += p.y;
      country.push_back( p );
   }    
   cout  << "городов " << country.size() << " : ";  
   for( auto &p : country ) cout << p << "  ";
   cout << endl;
   town cp( xm / country.size(), ym / country.size() );
   unsigned dist = summa( country, cp ), m = 1;
   bool bstp;
   do {
      town neib[] = {
         { 1, 0 }, { 1, 1 }, { 0, 1 }, { -1, 1 },
         { -1, 0 }, { -1, -1 }, { 0, -1 }, { 1, -1 }
      };
      bstp = false;
      town pm; 
      for( auto &p : neib ) {
         town pc = cp + p;
         if( find( country.begin(), country.end(), pc ) != country.end() )
            continue; 
         unsigned d = summa( country, pc ); //  cp + p );
         if( d < dist ) {
            dist = d;
            pm = pc; // cp + p;
            bstp = true;
         }
         m++;
      }
      if( bstp ) cp = pm;
   } while( bstp );    
   cout << "столица " << cp << " среднее расстояние " 
        << (float)dist / country.size() << " число проб " << m << endl;
}
